<html>
<head>
<title>Ogre::StaticFaceGroup Struct Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="structOgre_1_1StaticFaceGroup.html">StaticFaceGroup</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::StaticFaceGroup Struct Reference<div class="ingroups"><a class="el" href="group__Scene.html">Scene</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::StaticFaceGroup" -->
<p>Collects a group of static i.e.  
 <a href="structOgre_1_1StaticFaceGroup.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>&gt;</code></p>

<p><a href="structOgre_1_1StaticFaceGroup-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Scene.html#ga7c11c8a17d7bbfc5aab6f982fb0d7f38">FaceGroupType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#abc91f43284e36aa2376f4d54078f0480">fType</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#aa58eb0dbf0fdf7e625c80e7dbb0e76f9">isSky</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Is this a sky surface?  <a href="#aa58eb0dbf0fdf7e625c80e7dbb0e76f9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#a09215495af768e8a68b20cf1a937af3a">vertexStart</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Index into a buffer containing vertex definitions.  <a href="#a09215495af768e8a68b20cf1a937af3a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#a4b1e2bb83673099b9d2459a1bb67f429">numVertices</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The range of vertices in the buffer this facegroup references.  <a href="#a4b1e2bb83673099b9d2459a1bb67f429"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#a3f73219edf1201e9a3c769f9ccc672bf">elementStart</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Index into a buffer containing vertex indices.  <a href="#a3f73219edf1201e9a3c769f9ccc672bf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#a2dba19f0f06565cd111206a4a673239c">numElements</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of vertex indices.  <a href="#a2dba19f0f06565cd111206a4a673239c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#a697d56998dccec97a4670930ea7c2a41">materialHandle</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Handle to material used by this group.  <a href="#a697d56998dccec97a4670930ea7c2a41"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Plane.html">Plane</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#ad258e1806394cbd8b2efe7f39d3a7296">plane</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1PatchSurface.html">PatchSurface</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#a42cad07e5dea1a57a10304dcd7b7810b">patchSurf</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Patch surface (only applicable when fType = FGT_PATCH)  <a href="#a42cad07e5dea1a57a10304dcd7b7810b"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1StaticFaceGroup.html#ae57aba80895c22bb02f633d02be64edb">operator&lt;&lt;</a> (std::ostream &amp;o, const <a class="el" href="structOgre_1_1StaticFaceGroup.html">StaticFaceGroup</a> &amp;s)</td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Collects a group of static i.e. </p>
<p>immovable faces together which have common properties like the material they use, the plane they lie on. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Whilst for discrete geometry (i.e. movable objects) groups of faces are held in the <a class="el" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> class, for immovable objects like scenery there needs to ba little more flexibility in the grouping since the group is likely to be a small part of a huge set of geometry. In addition, because the faces are unmoving certain optimisations can be performed, e.g. precalculating a world-coordinate bounding box and normal. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>Exactly how this class is used depends on the format of the large static geometry used in the level. An example would be the use of this class in the BspNode class for indoor levels. For flexibility and efficiency, it is not assumed that this class holds details of the vertices itself, or in fact that it holds the vertex indices itself. Everything is manipulated via pointers so if you want this class to point into a block of geometry data it can. </dd></dl>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00069">69</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>
</div><hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="ae57aba80895c22bb02f633d02be64edb"></a><!-- doxytag: member="Ogre::StaticFaceGroup::operator&lt;&lt;" ref="ae57aba80895c22bb02f633d02be64edb" args="(std::ostream &amp;o, const StaticFaceGroup &amp;s)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> friend std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1StaticFaceGroup.html">StaticFaceGroup</a> &amp;&#160;</td>
          <td class="paramname"><em>s</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00113">113</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a3f73219edf1201e9a3c769f9ccc672bf"></a><!-- doxytag: member="Ogre::StaticFaceGroup::elementStart" ref="a3f73219edf1201e9a3c769f9ccc672bf" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#a3f73219edf1201e9a3c769f9ccc672bf">Ogre::StaticFaceGroup::elementStart</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Index into a buffer containing vertex indices. </p>
<p>This buffer may be individual to this group or shared for memory allocation efficiency.The vertex indexes are relative the the mVertexStart pointer, not to the start of the large-level buffer, allowing simple reindexing when copying data into rendering buffers. This is only applicable to FGT_FACE_LIST face group types. </p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00094">94</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="abc91f43284e36aa2376f4d54078f0480"></a><!-- doxytag: member="Ogre::StaticFaceGroup::fType" ref="abc91f43284e36aa2376f4d54078f0480" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Scene.html#ga7c11c8a17d7bbfc5aab6f982fb0d7f38">FaceGroupType</a> <a class="el" href="structOgre_1_1StaticFaceGroup.html#abc91f43284e36aa2376f4d54078f0480">Ogre::StaticFaceGroup::fType</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00071">71</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa58eb0dbf0fdf7e625c80e7dbb0e76f9"></a><!-- doxytag: member="Ogre::StaticFaceGroup::isSky" ref="aa58eb0dbf0fdf7e625c80e7dbb0e76f9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="structOgre_1_1StaticFaceGroup.html#aa58eb0dbf0fdf7e625c80e7dbb0e76f9">Ogre::StaticFaceGroup::isSky</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Is this a sky surface? </p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00074">74</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="a697d56998dccec97a4670930ea7c2a41"></a><!-- doxytag: member="Ogre::StaticFaceGroup::materialHandle" ref="a697d56998dccec97a4670930ea7c2a41" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#a697d56998dccec97a4670930ea7c2a41">Ogre::StaticFaceGroup::materialHandle</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Handle to material used by this group. </p>
<p>Note the use of the material handle rather than the material name - this is for efficiency since there will be many of these. </p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00105">105</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2dba19f0f06565cd111206a4a673239c"></a><!-- doxytag: member="Ogre::StaticFaceGroup::numElements" ref="a2dba19f0f06565cd111206a4a673239c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#a2dba19f0f06565cd111206a4a673239c">Ogre::StaticFaceGroup::numElements</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The number of vertex indices. </p>
<p>This is only applicable to FGT_FACE_LIST face group types. </p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00099">99</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4b1e2bb83673099b9d2459a1bb67f429"></a><!-- doxytag: member="Ogre::StaticFaceGroup::numVertices" ref="a4b1e2bb83673099b9d2459a1bb67f429" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#a4b1e2bb83673099b9d2459a1bb67f429">Ogre::StaticFaceGroup::numVertices</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The range of vertices in the buffer this facegroup references. </p>
<p>This is really for copying purposes only, so that we know which subset of vertices to copy from our large-level buffer into the rendering buffer. </p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00085">85</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="a42cad07e5dea1a57a10304dcd7b7810b"></a><!-- doxytag: member="Ogre::StaticFaceGroup::patchSurf" ref="a42cad07e5dea1a57a10304dcd7b7810b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1PatchSurface.html">PatchSurface</a>* <a class="el" href="structOgre_1_1StaticFaceGroup.html#a42cad07e5dea1a57a10304dcd7b7810b">Ogre::StaticFaceGroup::patchSurf</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Patch surface (only applicable when fType = FGT_PATCH) </p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00110">110</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad258e1806394cbd8b2efe7f39d3a7296"></a><!-- doxytag: member="Ogre::StaticFaceGroup::plane" ref="ad258e1806394cbd8b2efe7f39d3a7296" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plane.html">Plane</a> <a class="el" href="structOgre_1_1StaticFaceGroup.html#ad258e1806394cbd8b2efe7f39d3a7296">Ogre::StaticFaceGroup::plane</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00107">107</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<a class="anchor" id="a09215495af768e8a68b20cf1a937af3a"></a><!-- doxytag: member="Ogre::StaticFaceGroup::vertexStart" ref="a09215495af768e8a68b20cf1a937af3a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structOgre_1_1StaticFaceGroup.html#a09215495af768e8a68b20cf1a937af3a">Ogre::StaticFaceGroup::vertexStart</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Index into a buffer containing vertex definitions. </p>
<p>Because we're dealing with subsets of large levels this is likely to be part-way through a huge vertex buffer. </p>

<p>Definition at line <a class="el" href="OgreStaticFaceGroup_8h_source.html#l00079">79</a> of file <a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a>.</p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li><a class="el" href="OgreStaticFaceGroup_8h_source.html">OgreStaticFaceGroup.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:08
</p>
</body>
</html>
